require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe DispatchersController do

  # This should return the minimal set of attributes required to create a valid
  # Dispatcher. As you add validations to Dispatcher, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    { "address" => "MyString" }
  end

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # DispatchersController. Be sure to keep this updated too.
  def valid_session
    {}
  end

  describe "GET index" do
    it "assigns all dispatchers as @dispatchers" do
      dispatcher = Dispatcher.create! valid_attributes
      get :index, {}, valid_session
      assigns(:dispatchers).should eq([dispatcher])
    end
  end

  describe "GET show" do
    it "assigns the requested dispatcher as @dispatcher" do
      dispatcher = Dispatcher.create! valid_attributes
      get :show, {:id => dispatcher.to_param}, valid_session
      assigns(:dispatcher).should eq(dispatcher)
    end
  end

  describe "GET new" do
    it "assigns a new dispatcher as @dispatcher" do
      get :new, {}, valid_session
      assigns(:dispatcher).should be_a_new(Dispatcher)
    end
  end

  describe "GET edit" do
    it "assigns the requested dispatcher as @dispatcher" do
      dispatcher = Dispatcher.create! valid_attributes
      get :edit, {:id => dispatcher.to_param}, valid_session
      assigns(:dispatcher).should eq(dispatcher)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Dispatcher" do
        expect {
          post :create, {:dispatcher => valid_attributes}, valid_session
        }.to change(Dispatcher, :count).by(1)
      end

      it "assigns a newly created dispatcher as @dispatcher" do
        post :create, {:dispatcher => valid_attributes}, valid_session
        assigns(:dispatcher).should be_a(Dispatcher)
        assigns(:dispatcher).should be_persisted
      end

      it "redirects to the created dispatcher" do
        post :create, {:dispatcher => valid_attributes}, valid_session
        response.should redirect_to(Dispatcher.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved dispatcher as @dispatcher" do
        # Trigger the behavior that occurs when invalid params are submitted
        Dispatcher.any_instance.stub(:save).and_return(false)
        post :create, {:dispatcher => { "address" => "invalid value" }}, valid_session
        assigns(:dispatcher).should be_a_new(Dispatcher)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Dispatcher.any_instance.stub(:save).and_return(false)
        post :create, {:dispatcher => { "address" => "invalid value" }}, valid_session
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested dispatcher" do
        dispatcher = Dispatcher.create! valid_attributes
        # Assuming there are no other dispatchers in the database, this
        # specifies that the Dispatcher created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Dispatcher.any_instance.should_receive(:update_attributes).with({ "address" => "MyString" })
        put :update, {:id => dispatcher.to_param, :dispatcher => { "address" => "MyString" }}, valid_session
      end

      it "assigns the requested dispatcher as @dispatcher" do
        dispatcher = Dispatcher.create! valid_attributes
        put :update, {:id => dispatcher.to_param, :dispatcher => valid_attributes}, valid_session
        assigns(:dispatcher).should eq(dispatcher)
      end

      it "redirects to the dispatcher" do
        dispatcher = Dispatcher.create! valid_attributes
        put :update, {:id => dispatcher.to_param, :dispatcher => valid_attributes}, valid_session
        response.should redirect_to(dispatcher)
      end
    end

    describe "with invalid params" do
      it "assigns the dispatcher as @dispatcher" do
        dispatcher = Dispatcher.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Dispatcher.any_instance.stub(:save).and_return(false)
        put :update, {:id => dispatcher.to_param, :dispatcher => { "address" => "invalid value" }}, valid_session
        assigns(:dispatcher).should eq(dispatcher)
      end

      it "re-renders the 'edit' template" do
        dispatcher = Dispatcher.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Dispatcher.any_instance.stub(:save).and_return(false)
        put :update, {:id => dispatcher.to_param, :dispatcher => { "address" => "invalid value" }}, valid_session
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested dispatcher" do
      dispatcher = Dispatcher.create! valid_attributes
      expect {
        delete :destroy, {:id => dispatcher.to_param}, valid_session
      }.to change(Dispatcher, :count).by(-1)
    end

    it "redirects to the dispatchers list" do
      dispatcher = Dispatcher.create! valid_attributes
      delete :destroy, {:id => dispatcher.to_param}, valid_session
      response.should redirect_to(dispatchers_url)
    end
  end

end
